



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java进阶(四十六)简述ArrayList、Vector与LinkedList的异同点</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java进阶(四十六)简述ArrayList、Vector与LinkedList的异同点</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 14:56:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<h1>简述ArrayList、Vector与LinkedList的异同点</h1>
<p>  Collection类的继承图如下: <br /><br />
<img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20161008202512505"></p>
<p>  从图中可以看出,LinkedList与ArrayList、ArrayDeque这三者都实现了List接口.所有使用方式也很相似,主要区别在于因为实现方式的不同,所以对不同的操作具有不同的效率。</p>
<ul><li>ArrayList是一个可改变大小的数组.当更多的元素加入到ArrayList中时,其大小将会动态地增长。内部的元素可以直接通过get与set方法进行访问,因为ArrayList本质上就是一个数组。</li>
<li><p>List arrayList = new ArrayList(); <br /><br />
如果像上面这样使用默认的构造方法，初始容量被设置为10。当ArrayList中的元素超过10个以后，会重新分配内存空间，使数组的大小增长到16。可以通过调试看到动态增长的数量变化：10-&gt;16-&gt;25-&gt;38-&gt;58-&gt;88-&gt;…(增长幅度为：len/2 + 1)</p></li>
<li><p>LinkedList是一个双链表,在添加和删除元素时具有比ArrayList更好的性能.但在get与set方面弱于ArrayList。</p></li></ul>
<p>  当然,这些对比都是指数据量很大或者操作很频繁的情况下的对比,如果数据和运算量很小,那么对比将失去意义。</p>
<ul><li>Vector和ArrayList类似,但属于强同步类。如果你的程序本身是线程安全的(thread-safe,没有在多个线程之间共享同一个集合/对象),那么使用ArrayList是更好的选择。</li>
<li>Vector和ArrayList在更多元素添加进来时会请求更大的空间。Vector每次请求其大小的双倍空间，而ArrayList每次对size增长50%。而LinkedList还实现了Queue接口,该接口比List提供了更多的方法,包括 <br /><br />
offer(),peek(),poll()等。</li></ul>
<p>  注意: 默认情况下ArrayList的初始容量非常小,所以如果可以预估数据量的话,分配一个较大的初始值属于最佳实践,这样可以减少调整大小的开销。</p>
<ul><li>LinkedList与ArrayList、ArrayDeque的实现机制完全不同，ArrayList、ArrayDeque内部以数组的形式来保存集合中的元素，因此随机访问集合元素时有较好的性能；而LinkedList内部以链表的形式来保存集合中的元素，因此随机访问集合元素时性能较差，但在插入、删除元素时性能非常出色(只需改变指针所指的地址即可)。</li>
<li>如果需要遍历List集合元素，对于ArrayList、Vector集合，应该使用随机访问方法(get)来遍历集合元素，这样性能更好；对于LinkedList集合，则应该采用迭代器(Iterator)来遍历集合元素； <br /><br />
如果需要经常执行插入、删除操作来改变List集合的大小，则应该使用LinkedList集合，而不是ArrayList。使用ArrayList、Vector集合需要经常重新分配内部数组的大小，其时间开销往往是使用LinkedList的几十倍，效果更差；</li>
<li><p>如果有多个线程需要同时访问List集合中的元素，开发者可考虑使用Collections工具类将集合包装成线程安全的集合。</p>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20161008202634195"> <br /><br />
<img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20161008202828520"> <br /><br />
<img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20161008202656445"></div></li></ul>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e4oox9.html">JS实战 &amp;&num;183&semi; 级联菜单选择省份和城市（两种）</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq472j0q.html">jar包合并</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93l2yw9.html">VMware Workstation 下进行  桥连接</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnno1d8.html">Java面向对象深度</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e15j3k9.html">Visual Basic相关图书推荐</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvo3oyq.html">c&num; winform 隐藏tabcontrol标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o2z0v9.html">angularJs 使用中遇到的问题小结【二：购物车引起的问题思考】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1zp169.html">wpf 异步使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z17vwx9.html">IronPython fail to add reference to WebDriver&period;dll</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1e1v39.html">Delphi-CompareStr 函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x5doz9.html">Android 打开系统最近任务及最近应用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zk7de9.html">fiddler限制网速</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgvjo48.html">&lbrack;Swift&rsqb;LeetCode112&period; 路径总和 &vert; Path Sum</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1nzx5q.html">LoadLibrary 失败的解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j3ek5q.html">hdu   6058---Kanade&amp;&num;39&semi;s sum（链表）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5wzk4q.html">CentOS&plus;Nginx&plus;Supervisor部署ASP&period;NET Core项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5vk4eq.html">Mongodb集群搭建之 Sharding&plus; Replica Sets集群架构（2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5jdj4q.html">发布上线前，先小秀一把俺的64位浏览器，速度那觉对是杠杠滴，上youtube，上google不费劲</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppk5rz9.html">UVa 10340 子序列</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk3mrd8.html">03-python的新式类和经典类区别</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnj63438.html">pymysql实现从a表过滤出有效信息添加至b表</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z5x1j9.html">在iview的Table中添加Select（render）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd5jnk9.html">洛谷P2572 &lbrack;SCOI2010&rsqb;序列操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y1y5r8.html">&lbrack;4&period;14校内训练赛by hzwer&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgln378.html">Chinese-Text-Classification，用卷积神经网络基于 Tensorflow 实现的中文文本分类。</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eykmkx9.html">EffectiveTensorflow&colon;Tensorflow 教程和最佳实践</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pnmxv8.html">&lbrack;Java&rsqb; 设计模式：代码形状 - lambda表达式的一个应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rglyze8.html">将一个div置于另一个div之上</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyk5gx9.html">JVM内部原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/9501jx68.html">Redis学习汇总</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
